VERSION 5.00
Begin VB.Form frmHistory 
   Caption         =   "Historical Data"
   ClientHeight    =   8490
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6810
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   8490
   ScaleWidth      =   6810
   Begin VB.ListBox List1 
      Height          =   6690
      Left            =   0
      TabIndex        =   2
      Top             =   600
      Width           =   6855
   End
   Begin VB.Label lblShowSym 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   130
      Width           =   975
   End
   Begin VB.Label lblSymbol 
      Caption         =   "Symbol: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "frmHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem ----------------------------------------------------------------------------
Rem -- ABOUT THIS FORM
Rem -- ---------------
Rem --
Rem -- This form processes requests to the history server.
Rem ----------------------------------------------------------------------------

Rem ----------------------------------------------------------------------------
Rem -- DISCLAIMER AND DISTRIBUTION
Rem -- ---------------------------
Rem --
Rem -- All code, programming styles, and architecture are provided for
Rem -- demonstration purposes only, and may not be suitable for every project.
Rem --
Rem -- The code contained in this sample application may be used freely within
Rem -- third-party applications if the following criteria are met:
Rem --
Rem -- 1. This sample code must be a part of a larger application.
Rem -- 2. This sample code may not be packaged and distributed as a commercial
Rem --    product.
Rem ----------------------------------------------------------------------------


Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim sym As String
Dim requestHistoryHandle As Long
Dim sBar As String


Private Sub Form_Load()
    Me.Move 4050, 0, 7800, 9500
    List1.Width = ScaleWidth
    Set esignal = New IESignal.Hooks
End Sub



Public Sub getSym(sym As String)
    'Retrieve and display the symbol passed in from the Control Panel (frmMain,) and display it
    lblShowSym.Caption = sym
    
    'Clear any previous requests from the list
    List1.Clear

    'Retrieve history for the symbol passed in from the Control Panel (frmMain.)
    requestHistoryHandle = esignal.RequestHistory(sym, "D", btBARS, 9, -1, -1)
End Sub

'Note that this event is triggered automatically, as soon as data is
'returned for RequestHistory.  It does not need to be called explicitly.
Private Sub eSignal_OnBarsReceived(ByVal historyHandle As Long)
    'Check to see that the data returned is, in fact, for the symbol
    'presently requested.
    If requestHistoryHandle = historyHandle Then
        ProcessHistory (historyHandle)
    End If
End Sub

Public Sub ProcessHistory(historyHandle As Long)

    Dim lNumBars As Long
    Dim j As Integer
    Dim baritem As IESignal.BarData

    'Find out how many bars were returned
    lNumBars = esignal.GetNumBars(historyHandle)

    'Set the above number to its inverse for a decremented loop
    lNumBars = lNumBars * -1

    For j = lNumBars + 1 To 0
    
        'Retrieve the BarData data structure
        baritem = esignal.GetBar(historyHandle, j)
    
        'Parse through the structure and assign its values to variables
        vOpen = baritem.dOpen
        vHigh = baritem.dHigh
        vLow = baritem.dLow
        vClose = baritem.dClose
        dDate = Format(baritem.dtTime, "general date")
        
        'Build string and display it
        sBar = Format$(dDate) & vbTab & "Open=" & Format$(vOpen) & vbTab & "High=" & Format$(vHigh) & vbTab & "Low=" & Format$(vLow) & vbTab & "Close=" & Format$(vClose)
        List1.AddItem (sBar)
        
    Next j
    
    'The history handle must be released after use.  Note that
    'in some cases, ReleaseAllHistory may also be used.
    esignal.ReleaseHistory (historyHandle)
    
End Sub
