VERSION 5.00
Begin VB.Form frmRTbarData 
   Caption         =   "Real-time Bar Data"
   ClientHeight    =   7155
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7440
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   7155
   ScaleWidth      =   7440
   Begin VB.ListBox List1 
      Height          =   6495
      Left            =   0
      TabIndex        =   0
      Top             =   600
      Width           =   6255
   End
   Begin VB.Label lblShowSym 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1200
      TabIndex        =   2
      Top             =   10
      Width           =   975
   End
   Begin VB.Label lblSymbol 
      Caption         =   "Symbol: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "frmRTbarData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem ----------------------------------------------------------------------------
Rem -- ABOUT THIS FORM
Rem -- ---------------
Rem --
Rem -- This form processes real-time requests to the data manager.
Rem ----------------------------------------------------------------------------

Rem ----------------------------------------------------------------------------
Rem -- DISCLAIMER AND DISTRIBUTION
Rem -- ---------------------------
Rem --
Rem -- All code, programming styles, and architecture are provided for
Rem -- demonstration purposes only, and may not be suitable for every project.
Rem --
Rem -- The code contained in this sample application may be used freely within
Rem -- third-party applications if the following criteria are met:
Rem --
Rem -- 1. This sample code must be a part of a larger application.
Rem -- 2. This sample code may not be packaged and distributed as a commercial
Rem --    product.
Rem ----------------------------------------------------------------------------

Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim quote As IESignal.BasicQuote
Dim sym As String

Private Sub Form_Load()
    Me.Move 4050, 0, 7800, 9500
    List1.Width = ScaleWidth
    Set esignal = New IESignal.Hooks
End Sub

Public Sub getSym(sym As String)
    'Retrieve and display the symbol passed in from the Control Panel (frmMain,) and display it
    lblShowSym.Caption = sym
    
    'Clear any previous requests from the list
    List1.Clear
    
    'Retrieve data for the symbol passed in from the Control Panel (frmMain.)
    'OnQuoteChanged will automatically trigger.
    esignal.RequestSymbol sym, True 'True = streaming data, False = snapshot
End Sub

Public Sub esignal_OnQuoteChanged(ByVal sym As String)
    If sym = lblShowSym.Caption Then
       quote = esignal.GetBasicQuote(sym)
       qLast = quote.dLast
       qBid = quote.dBid
       qAsk = quote.dAsk
       
       If qLast <> 0 Then
        sBar = "Last = " & Format$(qLast) & vbTab & "Bid = " & Format$(qBid) & vbTab & "Ask = " & Format$(qAsk)
       End If
       
       List1.AddItem sBar, 0
    End If
End Sub


Private Sub Form_Unload(Cancel As Integer)
    esignal.ReleaseSymbol (sym)
End Sub
