VERSION 5.00
Begin VB.Form frmTickData 
   Caption         =   "Tick Data"
   ClientHeight    =   7230
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6450
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   7230
   ScaleWidth      =   6450
   Begin VB.ListBox List1 
      Height          =   2985
      Left            =   120
      TabIndex        =   0
      Top             =   4080
      Width           =   6255
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   615
      Left            =   1320
      TabIndex        =   4
      Top             =   840
      Width           =   4815
   End
   Begin VB.Label Current 
      Caption         =   "History tick:"
      Height          =   855
      Left            =   360
      TabIndex        =   3
      Top             =   840
      Width           =   855
   End
   Begin VB.Label lblSymbol 
      Caption         =   "Symbol: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   975
   End
   Begin VB.Label lblShowSym 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   10
      Width           =   975
   End
End
Attribute VB_Name = "frmTickData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Rem ----------------------------------------------------------------------------
Rem -- ABOUT THIS FORM
Rem -- ---------------
Rem --
Rem -- This form processes requests to the tick server.
Rem ----------------------------------------------------------------------------

Rem ----------------------------------------------------------------------------
Rem -- DISCLAIMER AND DISTRIBUTION
Rem -- ---------------------------
Rem --
Rem -- All code, programming styles, and architecture are provided for
Rem -- demonstration purposes only, and may not be suitable for every project.
Rem --
Rem -- The code contained in this sample application may be used freely within
Rem -- third-party applications if the following criteria are met:
Rem --
Rem -- 1. This sample code must be a part of a larger application.
Rem -- 2. This sample code may not be packaged and distributed as a commercial
Rem --    product.
Rem ----------------------------------------------------------------------------

Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim lLastTsCount As Long
Dim lLastTsRtCount As Long
Dim requestHandle As Long
Dim sym As String
Dim f_NumberOfRtBarsAdded As Long
Dim f_NumberOfBarsAdded As Long
Dim f_TotalNumberOfRtBars As Long
Dim f_TotalNumberOfBars As Long
Dim f_YesterdayDate As Date
Dim f_TotalNumberOfHistoryBarsToBeAdded As Long

Private Sub Form_Load()
    Me.Move 4050, 0, 7800, 9500
    List1.Width = ScaleWidth
    f_YesterdayDate = Now() - 1
    Set esignal = New IESignal.Hooks
    f_TotalNumberOfHistoryBarsToBeAdded = 0
End Sub

Public Sub getSym(sym As String)
    'Retrieve and display the symbol passed in from the Control Panel (frmMain,) and display it
    lblShowSym.Caption = sym
  
    'Clear any previous requests from the list
    List1.Clear

    'Establish information to be requested
    Dim tsFilter As IESignal.TimeSalesFilter
    tsFilter.sSymbol = sym
    tsFilter.bQuotes = True 'Request quotes
    tsFilter.bTrades = True 'Request trades
    tsFilter.lNumDays = 1   'Number of days for which you want data
    tsFilter.bFilterPrice = False  'True indicates that there is a price filter
                                   'associated with this request; False otherwise.
                                   'See page 4-7 of the documentation
    tsFilter.bFilterVolume = False 'True indicates that there is a volume filter
                                   'associated with this request; False otherwise.
                                   'See page 4-7 of the documentation
    tsFilter.bFilterQuoteExchanges = False 'True indicates that there is a filter of quote exchanges
                                           'associated with this request; False otherwise.
                                           'See page 4-7 of the documentation
    tsFilter.bFilterTradeExchanges = False 'True indicates that there is a filter of trade exchanges
                                           'associated with this request; False otherwise.
                                           'See page 4-7 of the documentation

    'Make request using info above.  OnTimeSalesChanged will automatically
    'trigger once there is a value in requestHandle
    requestHandle = esignal.RequestTimeSales(tsFilter)

End Sub


Private Sub esignal_OnTimeSalesChanged(ByVal tsHandle As Long)
    'Debug.Print ("OnTimeSalesChanged Fired")
    If f_TotalNumberOfHistoryBarsToBeAdded > 0 Then Exit Sub
If requestHandle = tsHandle Then
    
  'Debug.Print ("OnTimeSalesChanged:   " & tsHandle)
   'lHandle is the handle to the time sales request that requested
   'this data
   Dim lNumBars, lNumRtBars, lBar, lDiff As Long
   Dim item As IESignal.TimeSalesData

   lNumRtBars = esignal.GetNumTimeSalesRtBars(tsHandle) 'Gets number of
                                                         'real-time bars
   
   lNumBars = esignal.GetNumTimeSalesBars(tsHandle)      'Gets number of
                                                         'historical bars

   item = esignal.GetTimeSalesBar(tsHandle, -lNumBars + 1)
   Label1.Caption = "Currently Getting Data at" & Format$(item.dtTime)
   If item.dtTime > f_YesterdayDate Then Exit Sub
   
   f_TotalNumberOfHistoryBarsToBeAdded = lNumBars - lNumRtBars
   
   'Determine the number of new bars since the last event
   lDiff = (lNumRtBars - lLastTsRtCount) * -1

   For lBar = 0 To f_TotalNumberOfHistoryBarsToBeAdded
      item = esignal.GetTimeSalesBar(tsHandle, -lNumBars + lBar)  'Gets a TimeSalesData structure.
      
        If item.DataType = tsdBID Then
            sBar = Format$(item.dtTime) & vbTab & Format$(item.dPrice) & " (Bid)" & vbTab & Format$(item.sExchange)
        ElseIf item.DataType = tsdASK Then
                sBar = Format$(item.dtTime) & vbTab & Format$(item.dPrice) & " (Ask)" & vbTab & Format$(item.sExchange)
        Else
                sBar = Format$(item.dtTime) & vbTab & Format$(item.dPrice) & vbTab & vbTab & Format$(item.sExchange)
        End If

      'List1.AddItem sBar, 0
       Label1.Caption = sBar
   Next lBar
   
   'Remember the number of real-time bars so you can track how many
   'new real-time bars occur the next time.
   lLastTsRtCount = lNumRtBars
   
End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    esignal.ReleaseTimeSales (tsHandle)
End Sub
